/**
 ******************************************************************************
 * @file           : main.c
 * @author         : Auto-generated by STM32CubeIDE
 * @brief          : Main program body
 ******************************************************************************
 * @attention
 *
 * Copyright (c) 2022 STMicroelectronics.
 * All rights reserved.
 *
 * This software is licensed under terms that can be found in the LICENSE file
 * in the root directory of this software component.
 * If no LICENSE file comes with this software, it is provided AS-IS.
 *
 ******************************************************************************
 */

#include <stdint.h>
#include <stdio.h>
#include "stm32f4xx.h"
#include "SEGGER_SYSVIEW_Conf.h"
#include "SEGGER_SYSVIEW.h"
#include "FreeRTOS.h"
#include "task.h"
#include "semphr.h"
#include "queue.h"

char* message1 = "................................................................";
char* message2 = "++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++";

TaskHandle_t task1Handler;
TaskHandle_t task2Handler;
SemaphoreHandle_t writeAccessMutex;

int _write(int file, char *ptr, int len) {
    char *msg = ptr;
    SEGGER_SYSVIEW_Print(msg);
    // wait for other to complete printing
    if ( xSemaphoreTake( writeAccessMutex, ( TickType_t ) portMAX_DELAY) == pdTRUE ) {

      int DataIdx;
      for (DataIdx = 0; DataIdx < len; DataIdx++) {
        ITM_SendChar(*ptr++);
      }
      SEGGER_SYSVIEW_Print(msg);
      // done our job
      xSemaphoreGive (writeAccessMutex);
    }

    return len;
}

void PrintTask(void *argument) {
  char* name = pcTaskGetName(NULL);
  char* message = (char*)argument;
  char counter = 0;
  for(;;) {
    printf("%s: %03d %s\r\n",
        name,
        counter++,
        message
    );
    vTaskDelay(100);
  }
}

int main(void)
{
  SystemInit();
  SEGGER_SYSVIEW_Conf();
  SEGGER_SYSVIEW_Start();

  writeAccessMutex = xSemaphoreCreateMutex();

  xTaskCreate(
      PrintTask,
        "Task1",
        configMINIMAL_STACK_SIZE,
        (void *) message1,
        1,
        &task1Handler);

  xTaskCreate(
      PrintTask,
        "Task2",
        configMINIMAL_STACK_SIZE,
        (void *) message2,
        1,
        &task2Handler);

  vTaskStartScheduler();

	for(;;);
}
